
from functools import reduce

def word_num(word):
    return reduce(lambda x, y: x + ord(y) - ord('A') + 1, word, 0)

def is_tri_num(num):
    sqrt = int((2 * num) ** 0.5)
    return not ((sqrt + 1) * sqrt // 2 - num)

def file_get():
    with open('../resource/words.txt', 'r') as f:
        context = f.read().replace('"', '').split(',')
        return list(filter(lambda x: is_tri_num(x), map(lambda x: word_num(x), context)))

print(len(file_get()))

